-*-text-*-

2021-01-10

   Imported NOS data from snapshot 2020-12-23.  This includes a large number
   of new currents because harmonic constants for currents are now available
   through MDAPI.

   The currents are a clean break from previous years.  No data or metadata
   were carried over.  Coverage of the Salish Sea is mostly consistent with
   what was imported 2019-06; a few stations and depths were dropped, but
   the rest are equivalent.

   Cleaned up more typographical style issues in station names.

   Dropped a few more stations that appear to be in Canadian waters.

   Made a serious effort to harmonize the states of all tide and current
   stations with what Google Maps showed for the coordinates.  The resulting
   assignments may be surprising when the state line runs between the named
   landmark and the location of data collection.

   The following waters are especially problematic for assigning states:
   - St. Marys River
   - Savannah River
   - Pocomoke Sound and River
   - Delaware Bay and River
   - Everything around Long Island
   - Piscataqua River
   - Columbia River

2019-12-29

   Imported NOS data from snapshot 2019-12-18.

   Acquired 32 new or previously dropped current subs that refer to Salish
   Sea / Puget Sound stations that were imported over the summer.  3 of them
   collide with a harmonic current (Waldron Island).

   Added geographic areas to the names of stations imported 2019-06-20.

   Fixed inconsistent capitalization of "entrance" and
   "[north/south/east/west] jetty."

2019-06-20

   Imported new Salish Sea / Puget Sound currents that were obtained from
   NOAA by Charles Douglass (2019-06-11).

   Expired the superseded reference station
     PCT1956_1  Deception Pass (narrows), Washington Current
   and its three subordinates.

   All other data are untouched from 2018-12-27.

2018-12-27

   Imported NOS data from snapshot 2018-12-24 using MDAPI again.  There were
   no new subordinate stations, but some harmonic stations were added.

   Two more of the old current reference stations have expired.  AFAICT,
   harmonic constants for currents still have not been published on the NOAA
   web site.
     PCT2186_1  San Juan Channel (south entrance), Washington Current
     PCT1996_1  Rosario Strait, Washington Current

   The "wrong day" anomaly noted last year appears to have been fixed;
   however, there still are plenty of time zones or meridians mismatched by 1
   or 2 hours.

   In the SQL dump, table data_sets no longer provides oids.

2018-01-01

   Imported NOS data from snapshot 2017-12-17.  Most data this year were
   sourced from the CO-OPS Metadata API (MDAPI).

   The perennial issues with time zones and meridians in Alaska and around
   the Port St. Joe region of Florida have gotten worse all of a sudden.  The
   number of reference stations with local meridians in the wrong time zone
   has increased from 8 to 21.  Additionally, when local time predictions are
   obtained from the NOS web service, Alaskan stations that are expected to
   be 2 hours earlier than XTide's results (on UTC-11 instead of UTC-9)
   instead are 23 hours *later*, on the wrong day.  Predictions requested in
   GMT match as expected.

   Two more of the old current reference stations have expired.  AFAICT,
   harmonic constants for currents still have not been published on the NOAA
   web site.
     PCT1341  Strait of Juan de Fuca Entrance, Washington Current
     PCT1541  Admiralty Inlet (off Bush Point), Washington Current

   All remaining current stations now use "sidplus" station IDs, which is the
   station id followed by an underscore and the "bin number" that is used to
   separate depths.

   Abandoned the practice of including the periods in U.S.A., F.S.M., D.C.,
   and the like.

   Normalized the assignment of countries so that territories and
   commonwealths of the US are called USA.  Marshall Islands is now called
   RMI (Republic of the Marshall Islands).  Pending the conclusion of
   long-running territorial claims, Wake Island has been assigned the RMI
   country code, but its name is still "Wake Island, Pacific Ocean."

   Discontinued the last remaining meridian "erratum," for 9466153 Helmick
   Point.  Predictions are still not available for comparison, but there is a
   nearby station, 9466057 Popokamute (Kokokamute), which is consistent with
   the unadjusted data.

   Dropped the tables data_sets_2010, drops, and footnotes, which are no
   longer used by import, and all tables associated with the discontinued
   meridian errata check.

   Added 7 new constituent name aliases to support revised constants for
   Anchorage and constituent corrections as described below.

   The investigation into 3 questioned constituents (3KM5, RP1, and KJ2) that
   are used only by 9455920 Anchorage, Knik Arm, Cook Inlet, Alaska concluded
   the following:

   - Using this year's constants, which have amplitude for all 3 of the
   questioned constituents, RMS error for predicted heights versus the NOAA
   web site is indeed minimized when all 3 of those constituents are flipped
   180 degrees from their definitions in congen_input.txt 4154 2012-01-05
   (which is the same as congen_input.txt,v 1.3 2004/08/16).

   - Reaffirmed the decision made last year regarding 3KM5.  Although the
   superseded definition was consistent with IHO (2017), the new definition
   is the one that was used in the paper that introduced the use of many
   constituents for Anchorage (Bernard D. Zetler and Robert A. Cummings, A
   harmonic method for predicting shallow-water tides, J. Marine Res. 25(1),
   pp. 103-114, 1967) and is also the one used by IOS (2006).  The node
   factors are different for the two different formulations.

   - The definitions of RP1 and PSI1 (which are the same thing but flipped
   180 degrees) in congen_input.txt are consistent with IHO, with the SP98
   definition of PSI1, and with the IOS definition of PSI1.  Therefore, to
   reduce error for Anchorage, the RP1 constituent is just mapped to PSI1.

   - The definition of KJ2 in congen_input.txt is consistent with SP98 but
   inconsistent with IHO.  KJ2 and ETA2 in congen_input.txt are two different
   formulations of what IHO and IOS call ETA2, and the one apparently needed
   by Anchorage is not present.  Complicating matters, KJ2 is one of the
   constituents that is inferred by libtcd using an SP98 rule-of-thumb which
   assumes a consistent treatment of the constituents' phases; flipping KJ2
   from its SP98 definition would be more likely to break this inference than
   to fix it.  Therefore, to reduce error for Anchorage, KJ2 is mapped to a
   new constituent, KJ2-IHO, which is flipped from the SP98 definition.

   The new constants for Anchorage also refer to a mysterious constituent
   OO2, which has been mapped to OQ2-HORN based on its speed.  IHO defines
   OQ2 as both this constituent and its 180 degree reversal; however, error
   is minimized by sticking with the OQ2-HORN definition.

2016-12-31

   Imported NOS data from snapshot 2016-12-18.

   Changed the definition of constituent 3KM5, which is used only by
   Anchorage (9455920), from 3*K1+M2 to K1+M2+K2.
   - When calculated by Congen, K1+M2+K2 is close to but not exactly the same
     as a phase reversal of 3*K1+M2.
   - 3*K1+M2 was consistent with the 2006 IHO list.
   - Both IOS and the unidentified YEARDATA.dat application instead used
     K1+M2+K2.
   - The K1+M2+K2 definition decreases the differences between XTide's
     predictions and those of NOAA's web service.
   Details on the investigation of 3KM5 and the other constituents that were
   called into question last year are temporarily available at
   flaterco.com/xtide/news.html under To do / Congen.

   The Narrows, north end (midstream), Washington Current no longer matches
   NOAA predictions and has been expired along with all dependent subordinate
   stations.  PCT1766 was superseded by PUG1524 (3 different depths).
   AFAICT, harmonic constants for currents still have not been published on
   the NOAA web site.

   The erratum for Texaco Dock was removed because it matched predictions
   retrievable from the NOAA web site without adjustment.  The erratum for
   Helmick Point was retained by default as no predictions were retrievable.

   Fixed typo in Pillar Point Harbor, Half Moon Bay.

2015-12-27

   Imported NOS data from snapshot 2015-12-15.

   Note:  All comparisons with NOAA predictions now are using dynamically
   generated "online" predictions rather than "tables" that used to be posted
   annually.  Differences of 5 minutes are now common.

   *Tides*

   Harmonic constants are now being retrieved from
   opendap.co-ops.nos.noaa.gov/axis.

   Datums are now being retrieved from tidesandcurrents.noaa.gov/api.
   Benchmark Data Sheets are no longer used.  In the 37 cases where the API
   failed to return a usable value, the Benchmark Data Sheet either didn't
   exist or didn't help.  The same was true of online predictions.  Missing
   datums are still being set to an estimated MLLW that most often turns out
   to be lower than the value eventually adopted by NOAA.

   Datums for stations on the Columbia River have been corrected.
   Previously, import mishandled stations that were using the Columbia River
   Datum.  Bug report credit:  Mark Hayden.

   The time zone of Savoonga has been harmonized with the rest of
   St. Lawrence Island (HAST).  Wikipedia sources are now claiming that
   St. Lawrence Island is on AKST (which is where NOAA puts it), but see
   http://alaska.gov/kids/learn/timezones.htm:  "The far reaches of the
   Aleutian Islands and St. Lawrence Island are in the next zone,
   Hawaii-Aleutian Standard Time."  The 2003 CFR do not clearly address
   St. Lawrence Island at all, though by default, it appears that it should
   be on Alaska time.

   The errata for Texaco Dock and Helmick Point are unchanged.

   *Currents*

   Harmonic constants for currents still are not available for download.  The
   following reference current stations no longer match NOS predictions and
   have been expired along with all dependent subordinate stations:
     Old Tampa Bay Entrance (Port Tampa), Florida Current (15d)
     Tampa Bay (Sunshine Skyway Bridge), Florida Current (15d)

   The import of subordinate current stations has been migrated from the old
   Table 2-based pages, which still have not been posted for 2016, to the new
   "NOAA Current Predictions *Beta*" site.  Names now include "Depth Xft" in
   the middle instead of "(Xd)" at the end to indicate depths.  Legacy
   current refs were not renamed.

   The footnotes that used to be in Table 2 have been dropped.

   The harmonic constants for Wrangell Narrows obtained in 2011 were labelled
   as depth 6 ft.  They appear to match with the online predictions for depth
   4 ft and are being used for all subordinate stations that request the 4 ft
   reference.

   *Coordinates*

   The coordinates for all imported stations were taken preferably from the
   regional station lists.  Imported reference stations not included in the
   regional lists got their coordinates from the metadata of the harmonic
   constants.  The coordinates of legacy current refs were left alone.

   Coordinates retrieved from different places usually disagree with one
   another.  There is no general pattern such as rounding to the nearest
   minute to show that one or the other is better.  However, for a small
   sample of reference stations where the disagreement was large (9455606,
   9457527, 9465831), the station list coordinates were more plausible.

   Coordinates for American Samoa are now in the correct hemisphere.

   *Constituent definitions*

   I received untraceable evidence this year that NOAA may be using
   definitions of 3KM5, RP1, and KJ2 that are phase-reversed from what is in
   the harmonics file.  At present the only impacted NOAA station is
   Anchorage, where 3KM5 has amplitude of 0.04 ft and the other two are null.
   Comparison of all high/low tide predictions for Anchorage for year 2015
   with NOAA tides online showed on average a small improvement after
   flipping the phase of 3KM5:

                     Time RMSE (s)    Tide RMSE (cm)
   Default              63.7              2.1
   Phase-reversed       44.1              1.7

   Congen formulates 3KM5 as a compound constituent, which does not offer the
   opportunity to accidentally reverse the phase with a data entry error.
   More investigation is needed.  For now I am holding off on upheaving the
   constituent definitions, which would be a breaking change for anyone using
   harmonic constants from non-NOAA sources, and instead am merely flipping
   the phase of 3KM5 for Anchorage as an erratum.

   *Other notes*

   The anomaly with St. Michael, Norton Sound, Alaska is unchanged.

   Some stations show dramatically different names in the regional station
   list than on their prediction pages.  It is hopeless to try to identify
   all of these and figure out where they really are.

   "D.C.", "Washington, D.C." and "District of Columbia" have been
   standardized to just "D.C."

   Inconsistent capitalization in the names of subordinate current stations
   is not worth fixing.  XTide's name matching is case-insensitive.

2014-12-24

   Imported NOS data from snapshot 2014-12-16.

   Coordinates for reference stations had to be taken from a different page
   this year.  Many stations have moved slightly.

   The erratum for College Pt was removed because the meridian changed back.
   The erratum for Fortescue Creek was removed because the tide table now is
   consistent with the data.

   The harmonics for St. Michael, Norton Sound, Alaska are in disagreement
   with the subordinate station that is presently used for tide tables.
   Higher high tide differs by approximately 1.5 hours.  The correct fix is
   unclear; issue noted but no action.

   The 2013 footnotes table was reused again without further checking.

   Fixed time zone of Port Saint Joe again.

   Fixed spelling of McCready's Creek.

2013-12-28

   Imported NOS data from snapshot 2013-12-10.

   The following reference current stations no longer match NOS predictions
   and have been expired along with all dependent subordinate stations:
     Golden Gate Bridge, California Current (22d)
     San Francisco Bay Entrance (outside), California Current
     Key West, 0.3 mi. W of Ft. Taylor, Florida Current
     Cape Cod Canal (railroad bridge), Massachusetts Current

   Helmick Point added to errata for wrong meridian (thanks AED).

   The 2014 currents web site no longer provides footnotes, but the code
   still references them.  The 2013 footnotes table (from 2012-12 web scrape)
   was reused.  A sampling of stations that referenced footnotes showed no
   disagreement with the 2012 database.

2012-12-24

   Imported NOS data from snapshot 2012-12-22.
   Expired:  Mobile Bay Entrance (off Mobile Point), Alabama Current.
   Renamed several stations.

2012-03-02

   Imported up-to-date NOS harmonic constants for Golden Gate Bridge Current
   contributed by August Hahn, plus the 78 dependent subordinate stations
   from the web snapshot taken 2011-12-11.

   Note:  Change history prior to 2012-03-02 continues in
   http://www.flaterco.com/xtide/harmonics_boilerplate.txt.
